package commonStructures;
//import java.util.ArrayList;
import menuPackage.MenuItem;

public class OrderItem {
	private MenuItem mItem = null;
	private int qty = -1;
	private Order ownerOrder;
	private String status = "new";
	private OrderItemCopy[] copies;
	private int unservedIndx;
	
//	private EPlate plate = null;
	
	public OrderItem(MenuItem mI, int aQty){
		mItem = mI; qty = aQty;
		ownerOrder = null;
		status = "pending";
		copies = new OrderItemCopy[qty];
		for(int i=0; i<copies.length;i++)
			copies[i] = new OrderItemCopy(this);
		unservedIndx = 0;
	}
	
	public String getMIName(){ return mItem.getName();}
	public double getMIPrice(){return mItem.getPrice();}
	public void setStatus(String aStatus){status = aStatus;}
	public String getStatus(){return status;}
//	public void setPlate(EPlate aPlate){plate = aPlate; aPlate.setOrderItem(this);}
	
	public void setOrder(Order o){ownerOrder = o;}
	public Order getOrder(){return ownerOrder;}
	
	public void setPlateAsWaiting(EPlate aPlate){
		copies[unservedIndx].setStatus("waiting");
		copies[unservedIndx].setPlate(aPlate);
	}
	
	public void setPlateAsServed(EPlate aPlate){
		copies[unservedIndx].setStatus("served");
		if (qty > unservedIndx+1) unservedIndx++;
	}
	
	public boolean oiIsFullyServed(){
		boolean allServedFlag = true;
		for(int i=0; i< copies.length; i++){
			if(copies[i].getStatus().compareTo("served") !=0)
				allServedFlag = false;
		}
		return allServedFlag;
	}
	
	public String show(){return (getMIName() + "\t\tx " + qty  + ",\tTotal: " + qty*mItem.getPrice());}
	
	public int whatIsPending(){
		return qty - unservedIndx + 1;
	}
}
